﻿Imports CQG.Operators

''' <summary>
''' Simple Moving Average CQG operator. This implementation doesn't use state (calculates all period each time).
''' </summary>
<CQGOperator("VBMaOp(@, period)")>
Public Class VBMaOp : Implements IOperator

    ''' <summary>
    ''' Moving average period
    ''' </summary>
    Private _period As Integer = 21

    ''' <summary>
    '''  Implements <see cref="IOperator.Initialize"/>
    ''' </summary>
    Public Function Initialize(i_params As IDictionary(Of String, String), i_barsRebuilder As IBarsRebuilder) As Integer Implements IOperator.Initialize

        If Not String.IsNullOrEmpty(i_params("period")) Then
            _period = Convert.ToInt32(i_params("period"))
        End If

        Return _period

    End Function

    ''' <summary>
    '''  Implements <see cref="IOperator.Calculate"/>
    ''' </summary>
    Public Sub Calculate(i_inputs() As IList(Of Double), io_outputs() As Double, ByRef io_state As IDeepCloneable, io_primitives As IList(Of Object)) Implements IOperator.Calculate

        Dim sum As Double = 0.0
        For Each elem In i_inputs(0)
            sum += elem
        Next

        io_outputs(0) = sum / _period

    End Sub

End Class
