// studyprim.h is part of CQG COM Operators SDK

#pragma once

const int STUDY_PRIMITIVE_CURRENT_VERSION = 2;

class StudyPrimitiveInfo1
{
   short version;

public:
   enum eDrawingPrimitiveType type;
   long minute[2];
   short tickIndex[2];
   double pixelOffset[2];
   double value[2];
   LOGPEN pen;
   LOGBRUSH brush;
   enum HorizontalLabelAlignment hAlign;
   enum VerticalLabelAlignment vAlign;
   char label[10];
   int relativePenWidth; // must be in range: [-1000...1000]
   int borderWidth;
   int displaySymbol;
   bool transparent;
   int sizeFactor;
   int verticalOffset;
   bool useLabelAsTooltip; // tooltip contain only the primitive's label
   double sizeFactorMultiplier; // sizeFactor is multiplied to this field

   int compare(const StudyPrimitiveInfo1& other) const;

   inline bool operator == (const StudyPrimitiveInfo1& other) const
      { return compare(other) == 0; }
   inline bool operator < (const StudyPrimitiveInfo1& other) const
      { return compare(other) == -1; }

   StudyPrimitiveInfo1::StudyPrimitiveInfo1()
   {
      version = STUDY_PRIMITIVE_CURRENT_VERSION;
      type = DP_NONE;
      minute[0] = 0;
      tickIndex[0] = -32767;
      pixelOffset[0] = 0;
      value[0] = 0.0;
      minute[1] = 0;
      tickIndex[1] = -32767;
      pixelOffset[1] = 0;
      value[1] = 0.0;
      pen.lopnStyle = PS_SOLID;
      pen.lopnWidth.x = 1;
      pen.lopnWidth.y = 1;
      pen.lopnColor = 0;
      brush.lbStyle = BS_SOLID;
      brush.lbColor = 0;
      brush.lbHatch = HS_HORIZONTAL;
      hAlign = HLA_INVISIBLE;
      vAlign = VLA_INVISIBLE;
      for (int ii = 0; ii < 10; ii++) label[ii] = 0;
      relativePenWidth = 1;
      borderWidth = 1;
      displaySymbol = 0;
      transparent = 0;
      sizeFactor = 1;
      verticalOffset = 0;
      useLabelAsTooltip = true;
      sizeFactorMultiplier = 1.0;
   }

};

inline int StudyPrimitiveInfo1::compare(const StudyPrimitiveInfo1& other) const
{
   if (type < other.type) return -1;
   if (type > other.type) return  1;
   if (minute[0] < other.minute[0]) return -1;
   if (minute[0] > other.minute[0]) return  1;
   if (value[0] < other.value[0]) return -1;
   if (value[0] > other.value[0]) return  1;
   if (minute[1] < other.minute[1]) return -1;
   if (minute[1] > other.minute[1]) return  1;
   if (value[1] < other.value[1]) return -1;
   if (value[1] > other.value[1]) return  1;
   return 0;
}
