// studytypes.h is part of CQG COM Operators SDK

#pragma once

//  Items added to the enum eOperatorScaleDerivation must be
//  added at the end.  External COM based programs depend on
//  the order of these enum values.
enum eOperatorScaleDerivation
{
   OSD_NONE,          // invalid
   OSD_TRANSPARENT,   // transfer info-scale from a single input, and share chart scales (e.g. MA)
   OSD_COPY,          // copy info-scale from the input. (e.g. OSC)
   OSD_NEW,           // create a new info-scale, independent of input. (e.g. RSI)
   OSD_MERGE,         // merge 2 scales
   OSD_MATH_ADD,      // special rules for math addition (both for InfoScale, PriceScale)
   OSD_MATH_SUB,      // special rules for math subtraction
   OSD_MATH_SPREAD,   // special rules for math spread (subtraction of 2 symbols)
   OSD_MATH_MUL,      // special rules for math multiply
   OSD_MATH_DIV,      // special rules for math divide
   OSD_CUSTOM,        // custom rules (call COM operator)
   OSD_ASK_OPERATOR   // price scale determined by operator.
};

// defines for text display
#define TD_ABOVE  0x01
#define TD_BELOW  0x02
#define TD_NO_REP 0x04
#define TD_INT    0x08 // represent that next 4 bytes is integer, do not use with TD_SYMBOL
#define TD_COLOR0 0x00
#define TD_COLOR1 0x10
#define TD_COLOR2 0x20
#define TD_COLOR3 0x30
#define TD_SYMBOL 0x40

#if !defined( INVALID_VALUE)
#define INVALID_VALUE -2147483648.
#endif

#if !defined( INVALID_INTEGER)
#define INVALID_INTEGER ((long)0x80000000L)
#endif

#define CQGIC_DEFAULT_MAX_EXTRA_STEPS 400


