// MyMinMax.h is part of CQG COM Operators SDK Sample

#pragma once
#include <vector>
#include "resource.h"       // main symbols

#include "MyMinMaxSample.h"
#include "MyOperatorBase.h"

struct CMyMinMaxState
{
    double lastValidInput;
    std::vector< double > sequenceBuffer;
};

// CMyMinMax
class ATL_NO_VTABLE CMyMinMax :
   public CComObjectRootEx<CComMultiThreadModel>,
   public CComCoClass<CMyMinMax, &CLSID_MyMinMax>,
   public CMyOperatorBase<CMyMinMaxState>
{
public:
	CMyMinMax();

DECLARE_REGISTRY_RESOURCEID(IDR_MYMINMAX)

DECLARE_NOT_AGGREGATABLE(CMyMinMax)

BEGIN_COM_MAP(CMyMinMax)
    COM_INTERFACE_ENTRY(ICQGOp)
END_COM_MAP()

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}

	void FinalRelease()
	{
	}

public:
    ///@name ICQGOp interface methods
    ///@{
    STDMETHOD(GetTitle)(LPWSTR * o_title, LPWSTR * o_error);
    STDMETHOD(Initialize)(short i_ii, LPWSTR i_expression, LPWSTR * o_error);
    STDMETHOD(GetInputCount)(short * o_inputCount, LPWSTR * o_error);
    STDMETHOD(GetOutputCount)(short * o_outputCount, LPWSTR * o_error);
    STDMETHOD(GetOutputBarType)(short i_ii, LPWSTR * o_barTypeText, LPWSTR * o_error);
    STDMETHOD(GetParameterCount)(short * o_parmCount, LPWSTR * o_error);
    STDMETHOD(GetParameter)(short i_ii, LPWSTR * o_parameter, LPWSTR * o_error);
    STDMETHOD(GetExtraStepCount)(long * o_extraStepCount, LPWSTR * o_error);
    STDMETHOD(InitializeStep)(int i_sizeIn, double * i_lastValidInput);
    STDMETHOD(Calculate)(int i_sizeIn, double * i_input, int i_sizeOut, double * o_output);
    ///@}

private:
    int m_period;
};

OBJECT_ENTRY_AUTO(__uuidof(MyMinMax), CMyMinMax)
